; AppTitle
	AppTitle " :: 3D Dude :: "

; Set Graphics Mode, Double Buffer and No Mouse Pointer
	Graphics3D 800,600,0,0
	SetBuffer BackBuffer()
	HidePointer

; Globals
	Global FPS = 0, Frames = 0, Time# = MilliSecs() + 1 ; FPS Counter
	fntArial = LoadFont("Arial",15,False,True,False)  	; Font
	fntArialu = LoadFont("Arial",15,False,True,True)  	; Font
	Global BaseX = 50
	Global BaseZ = 50
	Global BaseY = 20
	playermove = 0
	collided = False
	chinks = 0

; Set collision type values 
	type_ground=1 
	type_character=2 
	type_scenery=3
	type_camera=4 

; Create Pivots
	pivdude = CreatePivot()
	EntityType pivdude,type_character
	pivcam = CreatePivot(pivdude)

; Create Camera
	camera=CreateCamera(pivcam)
	camsound = CreateListener(camera) 
	RotateEntity camera,45,0,0 
	PositionEntity camera,0,6,-15
	PointEntity camera,pivdude
	EntityRadius camera,1.5
	;;EntityType camera,type_camera

; Create Lightsource
	light=CreateLight() 
	RotateEntity light,45,0,0 

; Create Height Map and Textures
	texture = LoadTexture( "rhills_down.jpg" )
	terrain = LoadTerrain( "rhills_hmap.bmp" )
	PositionEntity terrain,-490,-25,-490
	EntityType terrain,type_ground
	ScaleTexture texture,50,50
	EntityTexture terrain,texture
	ScaleEntity terrain,4,40,4

; Create Dude 'character' 
	dude = CreateCone( 4,True,pivdude )
	EntityColor dude,0,0,200 
	EntityRadius dude,1
	EntityType dude,type_character
	RotateMesh dude,270,0,180
	ScaleEntity dude,1,0.5,2

; Create Walls
	walls = CreateCube()
	ScaleEntity walls,300,100,300
	PositionEntity walls,0,0,0
	FlipMesh walls
	EntityType walls,type_scenery
	EntityAlpha walls,0.1
	EntityColor walls,200,0,0

; Create Sky Dome
	skydome = CreateSphere(16)
	ScaleEntity skydome,500,500,500
	FlipMesh skydome
	skydometex = LoadTexture( "SkyDome.jpg" )
	EntityTexture skydome,skydometex
	
; Load Sound
	chink = LoadSound( "chink.wav" )

; Enable collisions between type_character and type_ground/type_scenery 
	Collisions type_character,type_ground,2,3
	Collisions type_character,type_scenery,2,1
	;;Collisions type_camera,type_ground,2,1

; Set Mouse Position
	oldmx = MouseXSpeed()
	oldmy = MouseYSpeed()

;  ------------------
; |Start of Main Loop|
;  ------------------
	While Not KeyDown( 1 ) 

	collided = False
	playermove = 0

	x#=0
	y#=0 
	z#=0 

; PivDude Movement
	
	If KeyDown( 30 )=True Then TurnEntity pivdude,0,1,0
		
	If KeyDown( 32 )=True Then TurnEntity pivdude,0,-1,0
	
	If KeyDown( 31 )=True Then 
	z#=-1
	playermove = 1
	End If
	
	If KeyDown( 17 )=True Then
	z#=1
  playermove = 1
	End if
	
	MoveEntity pivdude,x#,y#,z#
	MoveEntity pivdude,0,-0.5,0 ; gravity

; PivCam Movement
	If oldmx > MouseX() Then
		RotateEntity PivCam,(EntityPitch  (PivCam)),(EntityYaw ( PivCam)+oldmx),0
		oldmx = MouseXSpeed()
	End If

	If oldmx < MouseX() Then
		RotateEntity PivCam,(EntityPitch  (PivCam)),(EntityYaw ( PivCam)-oldmx),0
		oldmx = MouseXSpeed()
	End If

	If oldmy > MouseY() Then
		RotateEntity PivCam,(EntityPitch  (PivCam)+oldmy),(EntityYaw ( PivCam)),0
		oldmy = MouseYSpeed()
	End If

	If oldmy < MouseY() Then
		RotateEntity PivCam,(EntityPitch  (PivCam)+oldmy),(EntityYaw ( PivCam)),0
		oldmY = MouseYSpeed()
	End If

	MoveMouse GraphicsWidth()/2,GraphicsHeight()/2

; Reset Camera Position
	If MouseHit(1) Then
		RotateEntity PivCam,0,0,0
	End If

	PivDudeX = EntityX (pivdude)
	PivDudeZ = EntityZ (pivdude)

	PositionEntity skydome,PivDudeX,0,PivDudeZ

; Check for Collision	
	If EntityCollided (pivdude,3) Then
		collided = True
	End If

; Play Sound on Collision	
	If playermove = True And collided = True Then
	If Not ChannelPlaying(chinks) Then
	collided = False
	chinks = PlaySound (chink)
	End If
	End If

; FPS Counter
	Frames = Frames + 1
	If MilliSecs() >= Time FPS = Frames: Frames = 0: Time = Time + 1000

; Perform collision checking 
	UpdateWorld 

	RenderWorld 

; Text
	SetFont fntArialu
		Text 10,10,"Controls"
	SetFont fntArial
		Text 10,30,"Use WSAD to Move the Dude around the Map"
		Text 10,50,"Use the Mouse to move the Camera around the Dude"
		Text 10,70,"Use Mouse 1 to reset the Camera behind the Dude"
		Text 680, 10,"FPS: " + FPS		; Show FPS Text
		Text 680, 30,"X Co-Ord: " + PivDudeX
		Text 680, 50,"Z Co-Ord: " + PivDudeZ
		Text 680, 580,"Coded by Prophet"

	Flip 

	Wend 

	End 